/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * generated by Xtext 2.22.0
 */
package org.eclipse.trace4cps.tl.etl.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.trace4cps.tl.etl.AttributeFilter;
import org.eclipse.trace4cps.tl.etl.ConvSpec;
import org.eclipse.trace4cps.tl.etl.EtlPackage;
import org.eclipse.trace4cps.tl.etl.ResourceClientSignal;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Resource Client Signal</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.ResourceClientSignalImpl#getFilter <em>Filter</em>}</li>
 *   <li>{@link org.eclipse.trace4cps.tl.etl.impl.ResourceClientSignalImpl#getConvSpec <em>Conv Spec</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ResourceClientSignalImpl extends SignalImpl implements ResourceClientSignal
{
  /**
   * The cached value of the '{@link #getFilter() <em>Filter</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFilter()
   * @generated
   * @ordered
   */
  protected AttributeFilter filter;

  /**
   * The cached value of the '{@link #getConvSpec() <em>Conv Spec</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConvSpec()
   * @generated
   * @ordered
   */
  protected ConvSpec convSpec;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ResourceClientSignalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return EtlPackage.Literals.RESOURCE_CLIENT_SIGNAL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public AttributeFilter getFilter()
  {
    return filter;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFilter(AttributeFilter newFilter, NotificationChain msgs)
  {
    AttributeFilter oldFilter = filter;
    filter = newFilter;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER, oldFilter, newFilter);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setFilter(AttributeFilter newFilter)
  {
    if (newFilter != filter)
    {
      NotificationChain msgs = null;
      if (filter != null)
        msgs = ((InternalEObject)filter).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER, null, msgs);
      if (newFilter != null)
        msgs = ((InternalEObject)newFilter).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER, null, msgs);
      msgs = basicSetFilter(newFilter, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER, newFilter, newFilter));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ConvSpec getConvSpec()
  {
    return convSpec;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetConvSpec(ConvSpec newConvSpec, NotificationChain msgs)
  {
    ConvSpec oldConvSpec = convSpec;
    convSpec = newConvSpec;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC, oldConvSpec, newConvSpec);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setConvSpec(ConvSpec newConvSpec)
  {
    if (newConvSpec != convSpec)
    {
      NotificationChain msgs = null;
      if (convSpec != null)
        msgs = ((InternalEObject)convSpec).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC, null, msgs);
      if (newConvSpec != null)
        msgs = ((InternalEObject)newConvSpec).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC, null, msgs);
      msgs = basicSetConvSpec(newConvSpec, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC, newConvSpec, newConvSpec));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER:
        return basicSetFilter(null, msgs);
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC:
        return basicSetConvSpec(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER:
        return getFilter();
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC:
        return getConvSpec();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER:
        setFilter((AttributeFilter)newValue);
        return;
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC:
        setConvSpec((ConvSpec)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER:
        setFilter((AttributeFilter)null);
        return;
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC:
        setConvSpec((ConvSpec)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__FILTER:
        return filter != null;
      case EtlPackage.RESOURCE_CLIENT_SIGNAL__CONV_SPEC:
        return convSpec != null;
    }
    return super.eIsSet(featureID);
  }

} //ResourceClientSignalImpl
